package moduleexecution;

import java.awt.*;
import java.awt.Font;
import java.awt.LayoutManager;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.*;

import javax.swing.JPanel;
import structuresdonnees.*;

/* ----------------------------------------------------------*/
/* Classe matrialisant le pannneau execution */
/* ----------------------------------------------------------*/

public class PanneauExecution extends JPanel implements MouseListener {

	private PanneauAffichage sonPanelArbre;
	private BarreOutilsExecution saBarreOutils;
	private Font saPolice = new Font ("Arial",1,10);
	private ActionsExecution sesActions;
	private Lanceur sonLanceur; // Thread qui lance les algos 
	

	/* Accsseurs */
	public ActionsExecution getActions() { return sesActions;}
	public PanneauAffichage getPanneauAffichage() { return sonPanelArbre;}
	public Lanceur getLanceur() {return sonLanceur;}
	public void setLanceur(Lanceur telLanceur) {sonLanceur = telLanceur;}
	public BarreOutilsExecution getToolBar(){return saBarreOutils;}
	
	
		
	public PanneauExecution() {
		
		setLayout(new BorderLayout());
		
		
		sonPanelArbre = new PanneauAffichage(this);
		saBarreOutils = new BarreOutilsExecution(this);
		sesActions = new ActionsExecution(this);
		sonLanceur = new Lanceur(this);

		add(sonPanelArbre, BorderLayout.CENTER);
		add(saBarreOutils, BorderLayout.NORTH);
		validate();
		
	} // fin du constructeur
	
	
	/**
	 * @see MouseListener#mouseClicked(MouseEvent)
	 */
	public void mouseClicked(MouseEvent arg0) {
	}

	/**
	 * @see MouseListener#mousePressed(MouseEvent)
	 */
	public void mousePressed(MouseEvent arg0) {
	}

	/**
	 * @see MouseListener#mouseReleased(MouseEvent)
	 */
	public void mouseReleased(MouseEvent arg0) {
	}

	/**
	 * @see MouseListener#mouseEntered(MouseEvent)
	 */
	public void mouseEntered(MouseEvent arg0) {
	}

	/**
	 * @see MouseListener#mouseExited(MouseEvent)
	 */
	public void mouseExited(MouseEvent arg0) {
	}

}

