package structuresdonnees;

import java.util.Vector;

public class Ordonnancement
{
	/* Attributs */
	
	private int etape [][];
	/* stocke les tapes pour le mode pas  pas */
	private Vector pas_a_pas;

	/* Constructeur */
	public Ordonnancement (int nbrNoeud)
	{
		etape = new int [nbrNoeud][2];
		pas_a_pas = new Vector();
	}

	/* renvoie le pas  pas */
	public Vector getPas_a_Pas(){ return pas_a_pas;}
	
	/* permet de modifier le Vector pas_a_pas */
	public void setPas_a_Pas(Vector p){ pas_a_pas=p;}

	/* permet de modifier la ieme etape */
	public void setEtape(int i, int id, int conso)
	{
		etape[i][0] = id;
		etape[i][1] = conso;
	}
	
	/* retourne l'indice du noeud dans le tableau */
	public int getIndice(int i)	{ return etape [i][0]; }

	/* retourne la consommation du noeud */
	public int getConso (int i)	{ return etape [i][1]; }
	
	public boolean contains(int nb,int pos)
	{
		for(int i = 0; i<pos; i++)
		{
			if(etape[i][0]== nb)
				return true;
		}
		return false;
	}
	
	/* methode servant a creer un nvl ordo qui sera un clone de celui appelant la methode */
	public Object clone()
	{
		Ordonnancement retour = new Ordonnancement(this.etape.length);
		
		for(int i=0; i<this.etape.length; i++)
		{
			retour.setEtape(i, this.etape[i][0], this.etape[i][1]);
		}
		return retour;
	}		
	
	/* permet l affichage de l'ordo */
	public String toString()
	{
		String s = "";
		String t = "";
		for(int i=0; i<etape.length; i++)
		{
			s+=etape[i][0]+" ";
			t+=etape[i][1]+" ";
		}
		s+="\n";
		s+=t+"";

		return s;
	}
	
	public int[][] getEtape()
	{
		return	etape;
	}
	
	
}
