package structuresdonnees;


import java.util.Vector;

public class ordoA
{
	/* methode qui prend en parametre un arbre et qui genere un ordonnancement aleatoire valide */
	
	public Ordonnancement ordoAlea(ABP arbre)
	{
		
		int i = 0;
		int conso = 0;
		
		/* le vector courant contiendra au depart l ensemble des feuille de l arbre */
		Vector courant = new Vector();
		Vector pas_a_pas = new Vector();
		/* recuperation du nombre de noeud de l arbre et replissage de courant avec les feuille */
		int nbNoeud = arbre.getFeuille(courant);
		
		/* creation de la structure dans lakel sera stacker l ordonnancement */
		Ordonnancement ordo = new Ordonnancement(nbNoeud);
		
		/* boucle qui nous permettra de remonter l arbre j usqua la racine */
		while(( courant.size() != 0) && Usine.continu ())
		{
			pas_a_pas.add(courant.clone());
			/* selection aleatoire d un noeud parmi les noeuds possible */
			int alea = (int) Math.round((courant.size()-1) * Math.random());
			int noeud = ( (Integer)courant.remove(alea) ).intValue();
		
			/* calcul de la nouvelle consommation */
			conso = (arbre.estFeuille(noeud) ? ++conso : --conso);
			/* ajout du i ieme noeud de l ordonnancement */
			ordo.setEtape(i,noeud,conso);
			/* on marque que le noeud a ete vu */
			arbre.getObjNoeud(noeud).setMarque(true);
			
			/* si le frere du noeud courant a ete egalement vu on ajoute alors le pere a 
			 * la liste des noeud possible.
			 * cet verrification ne se fera pas si on est sur le racine 
			 */
			if( ( noeud%2 == 0 && arbre.getObjNoeud(noeud+1).getMarque() == true )
			 || ( noeud != 1 && noeud%2 == 1 && arbre.getObjNoeud(noeud-1).getMarque() == true ) )
				courant.add(new Integer(noeud/2));
				
			i++;
		}
		if (!Usine.continu ()) return null;
		ordo.setPas_a_Pas(pas_a_pas);
		return ordo;
	}	
}
