package structuresdonnees;


import java.util.Vector;

public class ordoT
{
	private void genOrdoT(Liste liste, Vector retour, Vector Pas_a_Pas, Ordonnancement ordonnancement,int pos, int conso, ABP arbre, boolean bool, int Stra)
	{
		/* dans cet methode la variable Stra servira seulement si la variable bool est vrai */
		
		/* si la liste est vide on a trouver un ordonnancement et on l ajoute a la liste */
		if( liste.isEmpty())
		{
			Ordonnancement o = (Ordonnancement)ordonnancement.clone();
			o.setPas_a_Pas((Vector)Pas_a_Pas.clone());
			
			retour.add(o);
			return;
		}
	
		Liste nouvel;
		int taille = liste.size();
		int newPos = pos + 1;
		
		Pas_a_Pas.add(liste);
		
		for(int i=0; i<taille && Usine.continu (); i++)
		{
			int newTaille = taille - 1;
			int noeud = liste.elementAt(i);
			
			int newConso = (arbre.estFeuille(noeud) ? conso + 1 : conso - 1);
		
			if(newConso <= Stra || bool == false)
			{
				ordonnancement.setEtape(pos, noeud, newConso);
				boolean modif = false;
			
				int nouveau = noeud/2;
			
				if( ( noeud%2 == 0 && ordonnancement.contains(noeud+1,pos))
				|| ( noeud != 1 && noeud%2 == 1 && ordonnancement.contains(noeud-1,pos)) )
				{
					modif = true;
					newTaille ++;
				}
				nouvel = (modif == true ? liste.pseudoClone(newTaille, i, nouveau) : liste.pseudoClone(newTaille, i, 0));
				newTaille --;
	
				this.genOrdoT(nouvel, retour, Pas_a_Pas,ordonnancement, newPos, newConso, arbre, bool, Stra);
			}
		}

		Pas_a_Pas.remove(liste);
	}
	
	public Vector Ordo(Vector feuille, int nbNoeud, ABP arbre, boolean bool)
	{
		Vector retour = new Vector();
		/* creation de la liste de feuille */
		int taille = feuille.size();
		int Stra = 0;
		
		/* si boole est vrai on veu seulement avoir les ordo optimum
		 * c a dire dont la consommation a tt moment ne depasse pas 
		 * le nombre de Strahler de la racine qui est la consommation
		 * minimal en registre pour evaluer cet arbre
		 */
		if(bool)
		{
			arbre.calculStrahler(1);
			Stra = arbre.getObjNoeud(1).getStrahler();
		}
		
		/* creation d une Liste qui contiendra tts les feuille des l arbres */
	
		Liste listeF = new Liste(taille);
		for(int i=0; i<taille; i++)
		{
			int k = ( (Integer)feuille.elementAt(i) ).intValue();
			listeF.add(k);
		}
		Vector Pas_a_Pas = new Vector();
		Ordonnancement ordonnancement = new Ordonnancement(nbNoeud);
		/* generation des ordo */
		this.genOrdoT(listeF, retour, Pas_a_Pas,ordonnancement, 0, 0, arbre, bool, Stra);
		
		if (!Usine.continu ()) return null;
		return retour;
	}

}
