package structuresgraphique;

import java.awt.Color;

public abstract class ConstantesFormes
{
	protected static double RAPPORT_ESPACE_LARGEUR = 7.1;
	protected static double COEFF_HAUTEUR_ESPACEMENT = 1.5;
	public static double LARGEUR_ELL = 17;
	public static double ESPACE = LARGEUR_ELL / RAPPORT_ESPACE_LARGEUR;
	
	public static double X_DEPART = 300;
	public static double Y_DEPART = LARGEUR_ELL * COEFF_HAUTEUR_ESPACEMENT;
	

	public static Color SOMMET_COLOR_TEXTE 		= Color.white;
	public static Color SOMMET_COLOR_CONTOUR	= Color.black;
	public static Color SOMMET_COLOR_RACINE	 	= Color.red;
	public static Color SOMMET_COLOR_FEUILLE 	= Color.blue;
	public static Color SOMMET_COLOR_SELECT  	= Color.orange;
	public static Color SOMMET_COLOR_AUTRES  	= Color.black;
	public static Color ARETE_COLOR 			= Color.black;

	// Courbe
    public static String TITRE_COURBE_ABCISSE  = "Noeuds" ;
    public static String TITRE_COURBE_ORDONNEE = "Consommation";
    public static String IMG_COURBE_FLECHEV    = "images/flecheV.PNG";	
	public static Color  COURBE_COLOR_DEFAUT   = Color.red;
}