package moduleparametrage;

import ihm.*;
import javax.swing.*;
import java.awt.*;
import moduleparametrage.*;

public class PanneauParametrage extends JPanel
{
	private PanneauSud ps = null;
	private PanneauCentre pc = null;

	private GridBagConstraints sesContraintes=new GridBagConstraints();

    public PanneauParametrage(IHM ihm)
    {
        setSize(500,300);
        setLayout(new GridBagLayout());

        ps = new PanneauSud(ihm);
        pc = new PanneauCentre(ihm);
        
        
        sesContraintes.fill=GridBagConstraints.HORIZONTAL;
        ParametrageConstante.add(0, 0, 1, 1, pc, sesContraintes, this);
        ParametrageConstante.add(0, 1, 1, 1, ps, sesContraintes, this);
    }
    
    public PanneauCentre getPanneauCentre()
    {
    	return pc;	
    }

    public PanneauSud getPanneauSud()
    {
        return ps;
    }
}
