package structuresdonnees;


public class genA{


	/* mthode rcursive qui renvoie un tableau d'entiers, de taille le nombre de noeuds,
 	 * 1 signifie qu'il existe un noeud, 0 qu'il n'en existe pas
 	 * Pour gnrer un ABP de hauteur h, on gnre un ABP de hauteur h-1, de 2^n -1 sommets ;
	 * on tire un sommet S au hasard entre 1 et 2n+1, on tire au hasard entre droit et gauche ;
	 * on remplace S par un nouveau sommet dont S devient le fils droit ou gauche, l'autre fils tant une feuille ;
	 */
	int cp = 0 ; /* compteur de sommets pour la gnration par nombre de noeuds */
	int nb ; /* variable stockant le nombre de noeuds ; */
	public int [] gen_Tab (int [] tab, int hauteur, int nbrNoeud)
	{
		int pos, dir, tmp=-1, cas=0 ;
		nb = nbrNoeud ;
		
		if( nbrNoeud != -1 ) cas = 1 ;
	 		 	 
	 	switch(cas)
	 	{
	 		case 0 :
	 			if( hauteur == 0 ) tab[1] = 1 ; /* On place la racine  la position 1 du tableau */
			 	else
			 	{
	 				/* On gnre un tableau de hauteur "hauteur"-1 */
	 				tab = gen_Tab(tab, hauteur-1, -1) ;
			 		/* On choisit un sommet alatoirement parmi ceux qui existent et qui n'ont pas de fils */
	 				pos = 1 + (int) (Math.random() * (Math.pow(2,hauteur)-1) ) ;
	 				while( tab[pos]==0 | (tab[2*pos]==0 && pos>1) ) pos = 1 + (int) (Math.random() * (Math.pow(2,hauteur)-1) ) ;
			 		/* dir correspond  choisir alatoirement droit ou gauche */	
			 		dir = (int) (Math.random() * 256) % 2 ;	// 256 arbitraire et peuttre inutile
	 				/* si dir=0, alors le sommet pos devient le fils gauche */
			 		if( dir==0 )
			 		{
	 					tmp = 2*pos ;
	 					tab[tmp] = 1 ;
	 					tab[tmp+1] = 1 ; /* l'autre fils du sommet pos */
	 					tab = ajout_fils(hauteur, tmp+1, tab) ;
	 				}
	 				else /* si dir=1, alors le sommet pos devient le fils droit */
			 		{
	 					tmp = 2*pos + 1 ;
	 					tab[tmp] = 1 ;	
	 					tab[tmp-1] = 1 ; /* l'autre fils du sommet pos */
	 					tab	= ajout_fils(hauteur, tmp-1, tab) ;
			 		}
	 		
	 				for( int i=2*pos ; i<((int)Math.pow(2, hauteur)-1) ; i=2*i )
	 				{
	 					tab[2*tmp] = tab[i] ;
	 					tab[2*tmp+1] = tab[i] ;
	 					tmp = 2*tmp ;
	 						 				
	 				}
	 			}
	 		break ;
	 		
	 		case 1 :
	 			
	 			/* Si on veut gnrer un ABP avec 1 noeud, on le place  la position 1 */
	 			if( nbrNoeud == 1 )
	 			{
	 				tab[1] = 1 ;
	 				cp ++ ; // on incrmente le nombre de sommets
	 			}
	 			else
	 			{
	 				/* On gnre un tableau de taille nbrNoeud-2 */
	 				tab = gen_Tab(tab, -1, nbrNoeud-2) ;
	 				nb = nbrNoeud ;
	 				
			 		/* On choisit un sommet alatoirement parmi ceux qui existent */
	 				pos = 1 + (int) (Math.random() * nbrNoeud)  ;
	 				while( tab[pos]==0 && pos>1 ) pos = 1 + (int) (Math.random() * nbrNoeud) ;
			 		/* dir correspond  choisir alatoirement droit ou gauche */	
			 		dir = (int) (Math.random() * 256) % 2 ;	// 256 arbitraire et peuttre inutile
				//	System.out.println("tab["+pos+"] = "+tab[pos]) ;
					
					/* si dir=0, alors le sommet pos devient le fils gauche */
			 		if( dir==0 )
			 		{
	 					tmp = 2*pos ;
	 					int k = tmp ;
	 					/* Mise  jour du tableau, probablement inutile */
	 					while( tab[k] != 0 )
	 					{
	 						tab[k] = 0 ;
	 						tab[k+1] = 0 ;
	 						cp = cp-2 ;
	 						k = k+2 ;	
	 					}
	 					tab[tmp] = 1 ;
	 					tab[tmp+1] = 1 ; /* l'autre fils du sommet pos */
	 					cp = cp+2 ; /* On incrmente le nombre de sommets dj crs */
	 				}
	 				else /* si dir=1, alors le sommet pos devient le fils droit */
			 		{
	 					tmp = 2*pos + 1 ;
	 					int k = tmp ;
	 					while( tab[k] != 0 )
	 					{
	 						tab[k] = 0 ;
	 						tab[k+1] = 0 ;
	 						cp = cp-2 ;
	 						k = k+2 ;
	 					}
	 					tab[tmp] = 1 ;	
	 					tab[tmp-1] = 1 ; /* l'autre fils du sommet pos */
	 					cp = cp+2 ; /* on incrmente le nombre de sommets dj crs */
	 				}
	 				/* Si on a cr le nbrNoeud, on quitte */
	 				if( cp == nb ) break ;
	 				
	 				int hmax = (nbrNoeud-1)/2  ;
	 				int hmin = (int) (Math.log(nbrNoeud-1)/(Math.log(2))) ;
					/* On dcale les noeuds dans le tableau */	 			
	 				for( int i=pos ; i<=hmax ; i=2*i )
	 				{
	 					/* si on a cr nbrNoeud, on quitte */
	 					if( cp == nb ) break ;
	 					if( hmax>1 && tab[2*pos] != 0 && (hmax != hmin || pos==1) )
	 					{
	 						/* s'il y a dj un fils en 2*tmp, on incrmente pas cp */
	 						if( tab[2*tmp] != 0 )
	 							cp = cp - 2 ;
	 							
	 						tab[2*tmp] = tab[i] ;
	 						tab[2*tmp+1] = tab[i] ;
	 						cp = cp + 2 ;
	 					 					
	 						/* s'il y a un fils droit, on incrmente tmp vers celui-ci */
	 						if( 2*(2*tmp+1)<=tab.length && tab[2*(2*tmp+1)] != 0 ) tmp = 2*tmp+1 ;
	 						else tmp = 2*tmp ;
	 					}
	 				}				 				
	 			}
	 		break ;
	 	}
	 	
		return tab ;	
	}
		
	/* Mthode qui dcide alatoirement si on ajoute des fils  la feuille ajoute 
	 * par la mthode gen_Tab.
	 */
	private int [] ajout_fils(int h, int pos , int [] tab)
	{
		int rang=0 ;
		/* Si pos est  l'tage 2^(h-rang), alors il est possible de lui ajouter rang tages de fils */
		/* A la sortie de la boucle for, rang = le nb d'tages qu'on peut ajouter au sommet pos */
		for( int i=h ; i>=0 ; i -- )
			if( pos >= (int)Math.pow(2, h-i) )
			{
				rang = i ;	
			}
		if( rang>0 )
		{
			/* On choisit alatoirement si on lui ajoute des fils ou non */
			int choix = (int) ( Math.random() * 256 ) % 2 ;
			
			if( choix==0 ) return tab ; /* on dcide que non */
			else
			{
				/* On lui ajoute alors un rang de fils et on appelle la fonction rcursivement sur ces fils */
				tab[2*pos] = 1 ;
				tab[2*pos+1] = 1 ;
				tab = ajout_fils(h, 2*pos, tab) ; 
				tab = ajout_fils(h, 2*pos+1, tab) ;
			}
		}
		return tab ;
	}
	
}
