package modulecreation;

import java.awt.Color;

abstract class ConstantesCreation
{
	public static boolean ANTI_ALIAS = true;
	public final static int LARGEUR_PANEL   = 10000;
	public final static int HAUTEUR_PANEL   = 10000;
	
	public static Color COULEUR_FOND = Color.white;
	
	// Les tooltips du panel de commande
	public final static String TOOLTIP_NOUVEAU   = "Creer un nouvel arbre";
	public final static String TOOLTIP_FERMER    = "Ferme l'arbre courant";
	public final static String TOOLTIP_FILS      = "Creer un fils";
	public final static String TOOLTIP_PREMIER   = "Affiche le 1er arbre";
	public final static String TOOLTIP_PRECEDENT = "Affiche l'arbre precedent";
	public final static String TOOLTIP_SUIVANT   = "Affiche l'arbre precedent";
	public final static String TOOLTIP_DERNIER   = "Affiche le dernier arbre";
	public final static String TOOLTIP_ANNULER   = "<HTML>Annule la derniere action<BR>(suppression ou deplacement de sous-arbre)</HTML>";
	public final static String TOOLTIP_ZOOM      = "Zoomer";
	public final static String TOOLTIP_UNZOOM    = "Dezoomer";
		
	// Texte Bouton
	public final static String TEXTE_NOUVEAU   = "Nouvel Arbre";
	public final static String TEXTE_FERMER    = "Fermer l'arbre";
	public final static String TEXTE_FILS      = "Creer un fils";
	public final static String TEXTE_PREMIER   = "Premier";
	public final static String TEXTE_PRECEDENT = "Precedent";
	public final static String TEXTE_SUIVANT   = "Suivant";
	public final static String TEXTE_DERNIER   = "Dernier";
	public final static String TEXTE_ANNULER   = "Annuler";
	
	// Textes des menu contextuels
	public final static String JMENU_SUPPRIMER = "Supprimer ce sommet";
	public final static String JMENU_MODIFIER  = "Modifier les donnees du sommet";
	public final static String JMENU_MODIFIERG = "Modifier les donnees de l'arete gauche";
	public final static String JMENU_MODIFIERD = "Modifier les donnees de l'arete droite";
	public final static String JMENU_NOUVEAU   = "Nouvel arbre a partir de ce sous-arbre";
	public final static String JMENU_DEP_SS_A  = "Deplacer ce sous-arbre (sans la racine)";
	public final static String JMENU_COP_SS_A  = "Copier ce sous-arbre (sans la racine)";
	public final static String JMENU_ANNULER   = "Annuler (Ferme le menu)";

	// Chemins des images
	public final static String IMG_NEW     = "images/new.png";
	public final static String IMG_CLOSE   = "images/close.png";
	public final static String IMG_FILS    = "images/fils.png";
	public final static String IMG_FIRST   = "images/first.png";
	public final static String IMG_PREV    = "images/previous.png";
	public final static String IMG_NEXT    = "images/next.png";
	public final static String IMG_LAST    = "images/last.png";
	public final static String IMG_UNDO    = "images/undo.png";
	public final static String IMG_ZOOM    = "images/zoom.png";
	public final static String IMG_UNZOOM  = "images/unzoom.png";
	
	// Pour les zooms
	public static double SCALE = 1;
	public final static double MIN_SCALE = 0.5;
	public final static double MAX_SCALE = 2.0;
}