package structuresdonnees;


import java.util.Vector;
import java.awt.Color;

public class Noeud
{
		/* Attributs */

		private int strahler; /* nombre de strahler */
		private Color couleur; /* couleur du noeud */
		private static int nbrNoeud = 0; /* nombre total de noeud */
		private Vector infosNoeud, infosArete;
		private boolean marque; /* permet de savoir si un noeud est marqu */
		private int label;

		/* Constructeurs */

		public Noeud ()
		{
				/* initialisation du nombre de strahler */
				strahler = 1;
				label = 0;
		}
		
		public Noeud (int label)
		{
			strahler = 1;
			this.label = label;
		}
		
		/* permet de marquer le noeud */
		public void setMarque(boolean b){ marque = b; }
		/* permet de savoir si le noeud est marquer */
		public boolean getMarque(){ return marque; }
		/* rcupre le nombre de Strahler */
		public int getStrahler () { return strahler; }
		/* permet de modifier le nombre de Strahler */
		public void setStrahler (int strahler) { this.strahler = strahler; }
		/* rcupre la valeur de la couleur */
		public Color getCouleur () { return couleur; }
		/* permet de modifier la couleur du noeud */
		public void setCouleur (Color couleur) { this.couleur = couleur; }
		/* rcupre les infos du noeud */
		public Vector  getInfosNoeud () { return infosNoeud; }
		/* rcupre les infos de l'arete */
		public Vector  getInfosArete () { return infosArete; }
		/* enregistre les infos relatives au noeud et  son arete mre */
		public void setInfosNoeud (Vector infosNoeud) {
				this.infosNoeud = infosNoeud;
		}
		public void setInfosArete (Vector infosArete) {
				this.infosArete = infosArete;
		}
		
		public int getLabel()
		{
			return label;
		}
		
		public String toString() {
			return ""+strahler+"" ;
		}
}
