package structuresdonnees;

import java.util.Vector;

public class ordoOptT
{
	/* methode generant les ordonnacement de l'arbre 
	 * l'entier courant represente la position du noeud ds le tableau
	 */
	private Vector genOrdoOpt(int courant,Vector pas_a_pas, ABP arbre)
	{	
		int toto = pas_a_pas.size();
		for(int k=0;k<toto;k++)
		{
			((Vector)pas_a_pas.elementAt(k)).add( new Integer(courant) );
		}

		if(arbre.estFeuille(courant))
		{
			Vector temp = new Vector();
			temp.add(new Integer(courant));
			Vector retour = new Vector();
			retour.add(temp );
			retour.add(pas_a_pas);
			return retour;
		}
		else
		{
			
			Vector pas1 = new Vector();
			Vector tmppas1 = new Vector();
			pas1.add(tmppas1);
			Vector pas2 = new Vector();
			Vector tmppas2 = new Vector();
			pas2.add(tmppas2);
			
			Vector droite;
			Vector gauche;
			
			int StraG = arbre.getObjNoeud(2*courant).getStrahler();
			int StraD = arbre.getObjNoeud(2*courant+1).getStrahler();
			
			droite = this.genOrdoOpt(2*courant+1,pas1, arbre);
			gauche = this.genOrdoOpt(2*courant,pas2, arbre);
			if (!Usine.continu ()) return null;
			pas2 = (Vector)gauche.lastElement();
			gauche.remove(pas2);
			
			pas1 = (Vector)droite.lastElement();
			droite.remove(pas1);
			
			if(StraD == StraG)
					pas_a_pas = this.makePas(true,true,pas1,pas2,pas_a_pas,courant);
			
			else if(StraD > StraG)
				pas_a_pas = this.makePas(false,true,pas1,pas2,pas_a_pas,courant);
				
			else
				pas_a_pas = this.makePas(true,false,pas1,pas2,pas_a_pas,courant);
			
			Vector retour = new Vector();
			
			int tailleD = droite.size();
			int tailleG = gauche.size();
			
			for(int i=0; i<tailleD && Usine.continu (); i++)
			{
				for(int j=0; j<tailleG; j++)
				{
				
					if(StraD == StraG)
					{
						/* ordonnancement */
						Vector temp1 = new Vector((Vector)droite.elementAt(i));
						Vector temp2 = new Vector((Vector)gauche.elementAt(j));
						temp1.addAll((Vector)gauche.elementAt(j));
						temp2.addAll((Vector)droite.elementAt(i));
						
						temp1.add( new Integer(courant));
						temp2.add( new Integer(courant));
						
						retour.add(temp1);
						retour.add(temp2);
						
						
				
					}
					else if(StraD > StraG)
					{
						/* ordonnancement */
						Vector temp1 = new Vector((Vector)droite.elementAt(i));
						Vector temp2 = new Vector((Vector)gauche.elementAt(j));
						temp1.addAll((Vector)gauche.elementAt(j));
						
						temp1.add( new Integer(courant));
						
						retour.add(temp1);
						
						
					}
			
					else
					{
						Vector temp1 = new Vector((Vector)droite.elementAt(i));
						Vector temp2 = new Vector((Vector)gauche.elementAt(j));
						
						temp2.addAll((Vector)droite.elementAt(i));
							
						temp2.add( new Integer(courant));
						
						retour.add(temp2);
					}
				}
			}
			if (!Usine.continu ()) return null;
			retour.add(pas_a_pas);
			return retour;
		}
	}
	
	
	private Vector makePas(boolean bool1, boolean bool2, Vector pas1, Vector pas2, Vector pas_a_pas, int courant)
	{
		int taille = pas1.size();
		int fin = pas2.size();
		int toto = pas_a_pas.size();
		
			
		Vector tata = new Vector();
				
		for(int i=0; i<taille;i++)
		{
			for(int j=0;j<fin;j++)
			{
				for(int k=0;k<toto;k++)
				{
					if(bool2)
					{		
						Vector titi = (Vector)((Vector)pas_a_pas.elementAt(k)).clone();
						titi.addAll((Vector)pas1.elementAt(i));
						titi.add( new Integer(courant) );
						titi.addAll((Vector)pas2.elementAt(j));
						titi.add( new Integer(courant) );		
						tata.add(titi);
					}
					if(bool1)
					{	
						Vector tmp = (Vector)((Vector)pas_a_pas.elementAt(k)).clone();
						tmp.addAll((Vector)pas2.elementAt(j));
						tmp.add( new Integer(courant) );
						tmp.addAll((Vector)pas1.elementAt(i));
						tmp.add( new Integer(courant) );
						tata.add(tmp);
					}
				}	
			}	
		}
		return tata;
		
	}
	
	public Vector ordo(ABP arbre)
	{
		Vector pas_a_pas = new Vector();
		Vector temp = new Vector();
		pas_a_pas.add(temp);
		
		Vector liste = this.genOrdoOpt(1, pas_a_pas, arbre);
		pas_a_pas =  (Vector)liste.lastElement();
		liste.remove(pas_a_pas);
		
		int nbrNoeud = ( (Vector)liste.elementAt(0) ).size();
		int taille = liste.size();
		
		for(int i=0; i<taille; i++)
		{
			int conso = 0;
			Ordonnancement ordonnancement = new Ordonnancement(nbrNoeud);
			ordonnancement.setPas_a_Pas((Vector)pas_a_pas.elementAt(i));

			temp = (Vector) liste.elementAt(i);
			for(int j=0; j<nbrNoeud; j++)
			{
				int id = ( (Integer)temp.elementAt(j) ).intValue();
				if( arbre.estFeuille(id) ) 
					conso++;
				else
					conso --;
				ordonnancement.setEtape(j,id,conso);
			}
			arbre.addOrdo(ordonnancement);
		}
		
		return arbre.getOrdo();
	}
	
}
