package structuresgraphique;


public class Stockage
{
	private String sonNom=null;
	private String sonContenu=null;
	
	
	public Stockage()
	{
		sonNom="";
		sonContenu="";
	}
	
	public Stockage(String telNom, String telContenu)
	{
		sonNom=telNom;
		sonContenu=telContenu;
	}
	
	public String getNom(){return sonNom;}
	public String getContenu(){return sonContenu;}
	
	public void setNom(String telNom){sonNom=telNom;}
	public void setContenu(String telContenu){sonContenu=telContenu;}
	
	public int compareTo(Object telObj)
	{
		if(sonNom.equals(((Stockage)telObj).getNom()) && 
			sonContenu.equals(((Stockage)telObj).getContenu()))
				return 0;
		else
				return -1;
	}
	
/*	public Object clone()
	{
		Stockage leClone=null;
		try
		{
			leClone=(Stockage)super.clone();
		}
		catch(CloneNotSupportedException cnse){ return null; }
		
		return leClone;
	}*/
	
	public boolean egal(Stockage telS)
	{
		return sonNom.equals(telS.getNom()) && sonContenu.equals(telS.getContenu());
	}
}