package ihm;

import java.awt.*;
import java.awt.event.*;
import java.awt.color.*;
import javax.swing.*;

import modulecreation.UnPanelDessinBase;

public class TestDrag1
{
	public static void main(String [] telArg)
	{
		new UneFenetre();
	}
}

class UneFenetre extends JFrame implements ActionListener
{
	private UneBarreDeMenu saBarreDeMenu=new UneBarreDeMenu();
	private JTabbedPane lesOnglets=new JTabbedPane();
	private JPanel lePanel = new JPanel();
	JButton telButt = null;
	JLabel telLabel;
	
	private UnPanelDessinBase telDessinBase;

	public UneFenetre()
	{
		super(Constantes.TITRE_FENETRE);
		setJMenuBar(saBarreDeMenu);

		telDessinBase = new UnPanelDessinBase();

	//	telDessinBase.setCouleurFondPanel(Color.white);		// Couleur de fond des panels de creation
	//	telDessinBase.setColorTexteSommets(Color.white);	// Couleur du texte des sommets
	//	telDessinBase.majColorRacine(Color.yellow);
	//	telDessinBase.majColorAutresSommets(Color.red);
	//	telDessinBase.majColorFeuilles(Color.blue);
	//	telDessinBase.majColorColorContourSommets(Color.cyan);
	//	telDessinBase.majDiametreSommets(50);
	//	telDessinBase.setAntiAlias(true);	

		lesOnglets.add(telDessinBase,"Creation");
		getContentPane().add(lesOnglets);

		// Taille de la fenetre
		setSize(Constantes.LARGEUR_FENETRE, Constantes.HAUTEUR_FENETRE);
		
		// Fenetre au milieu de l'ecran
	    int width =Toolkit.getDefaultToolkit().getScreenSize().width ;
    	int height=Toolkit.getDefaultToolkit().getScreenSize().height;
       	setLocation((width-Constantes.LARGEUR_FENETRE)/2,(height-Constantes.HAUTEUR_FENETRE)/2); 
       	
    	setVisible(true);	
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource() == telButt)
		{
			telLabel.setText(""+telDessinBase.getCurrentPanelDessin());
		}	
	}
}

class UneBarreDeMenu extends JMenuBar
{
	private String [] sesIntitulesJMenu = {"Fichier","Edition","?"};
	private JMenu [] sesJMenu=new JMenu[sesIntitulesJMenu.length];
	
	
	private String[][] sesIntitulesMenuItem =
	{ {"Ouvrir","Quitter"},
	  {"rien"},
	  {"A propos"}};
	  
	private JMenuItem[][] sesMenuItem = new JMenuItem[sesIntitulesMenuItem.length][sesIntitulesMenuItem[0].length];
	
	public UneBarreDeMenu()
	{
		super();
		
		for(int i = 0; i < sesIntitulesJMenu.length ; i++)
		{
			sesJMenu[i]=new JMenu(sesIntitulesJMenu[i]);
			sesJMenu[i].setEnabled(false);
			add(sesJMenu[i]);
			
			for(int j=0 ; j < sesIntitulesMenuItem[i].length ; j++)
			{
				sesMenuItem[i][j] = new JMenuItem(sesIntitulesMenuItem[i][j]);
				sesJMenu[i].add(sesMenuItem[i][j]);
			}	
		}
			
	}	
}

abstract class Constantes
{
	public final static String TITRE_FENETRE = "Creation d'arbre v0.1 beta :-)";
	public final static int LARGEUR_FENETRE = 1000;
	public final static int HAUTEUR_FENETRE = 600;

}